package event_listbox;

use Tk;
use Tk::MListbox;
use filter;
use IPC::Open3;
use IO::Select;
use log_select;

$dw=undef;
$max_event_entry=0;
$min_event_entry=0;
$ml=undef; 
$mw="";
$sw="";
$error_label="";
$filter_events=0;
$cat_label="";
$euid_label="";
$ruid_label="";
$date_label="";
$time_label="";
$host_label="";

############################
#
#
sub sort_date{

    ($a,$b) = @_;

    my  %date=(Jan=>"00",
	       Feb=>"01",
	       Mar=>"02",
	       Apr=>"03",
	       May=>"04",
	       Jun=>"05",
	       Jul=>"06",
	       Aug=>"07",
	       Sep=>"08",
	       Oct=>"09",
	       Nov=>"10",
	       Dec=>"11");

    $a =~ s/://g;
    $b =~ s/://g;

    ($day,$month,$day,$time,$year) = split(/ /,$a);
    $a = $year.$date{$month}.$day.$time;

    ($day,$month,$day,$time,$year) = split(/ /,$b);
    $b = $year.$date{$month}.$day.$time;
  
    $a <=> $b;
}

############################
#
#
sub status_window{

    my $x = shift;
    my $y = shift;

    $sw = MainWindow->new();
  
    $sw->title("Status Window");
    $sw->resizable(0,0);
    $sw->geometry("415x280+$x+$y");

    $error_window = $sw->Scrolled("Text",-height=>15,-width=>54)
	->place(-x=>0,-y=>0);

    $sw->Button(-text=>"Cancel",-command=>sub{$sw->destroy();})
	->place(-x=>170,-y=>240);

    MainLoop;
}

############################
#
#
sub initialize_listbox{

    $mw = shift;

    $ml->destroy() if Tk::Exists($ml);
    $ml = $mw->Scrolled('MListbox',-scrollbars=>'oe',
			-columns=>[[-text=>'Type',-textwidth=>9],
				   [-text=>'Source',-textwidth=>14],
				   [-text=>'Date/Time',-textwidth=>27,
                                 -comparecmd=> sub { sort_date($_[0],$_[1]);}],
				   [-text=>'Ruid',-textwidth=>10],
				   [-text=>'Euid',-textwidth=>10],
				   [-text=>'Host',-textwidth=>25],
				   [-text=>'Details',-textwidth=>20]
				   ]);

    $ml->pack(-expand=>1,-fill=>'both');
   
    run_cmd($cmd,$re);
}

############################
#
#
sub run_cmd{

    my $cmd = shift;
    my $re = shift;
    my $field;
    my $param = "";
    my $pid;
    my $err="";
    my $s="";
 
    $param = filter::get_filter_params();    
    $audit_files = log_select::get_audit_trail_params();
    
    $mw->configure(-cursor=>'watch');

    $cpid = fork();

    if($cpid!=0){
	$pid = open3(*CMD_IN,
		     *CMD_OUT,
		     *CMD_ERR,
         "auditreduce  $param  $audit_files| praudit -s");
 
	$SIG{CHLD} = sub { waitpid($pid,0); };
	$SIG{USR1} = sub{ close(CMD_OUT);
			  waitpid($cpid,0);
                          $mw->configure(-cursor=>'arrow');         
		      };

	print CMD_IN "test","\n";
	close(CMD_IN);

	$selector = IO::Select->new();
	$selector->add(*CMD_ERR,*CMD_OUT);

	$index=0;
	$event_count ="";

	while(@ready = $selector->can_read){
       
	    foreach $fh (@ready){
            
		if(fileno($fh) == fileno(CMD_ERR)){
		    $err = (scalar <CMD_ERR>);
          
		    if($err =~ /\s*[!-~]+/){
			if(!Exists($sw)){
			    status_window($mw->x(),$mw->y());
			}
			$error_window->insert('end',"$err\n");
		    }
		}elsif(fileno($fh) == fileno(CMD_OUT)){       
	    
		    if(process_events(\*CMD_OUT,\@data)){
			$ml->insert('end',\@data);
			$detail = $data[6];
			$detail[$index] = $detail;
			$index++;
			$event_count = $index." events loaded";               
		    }
		}
		$selector->remove($fh) if eof($fh);
	    }
	}
  
	while(process_events(\*CMD_OUT,\@data)){
	    $ml->insert('end',\@data);
	    $detail = $data[6];
	    $detail[$index] = $detail;
	    $index++;
	    $event_count = $index." events loaded";                    
	}
 
	$min_entry = 0;
	$max_entry = $index-1;
  
	# sort the date column
	# $ml->sort(0,2);

	$ml->bindRows("<Double-Button-1>",\&detail_dialog);

	close(CMD_OUT);
	close(CMD_ERR);

	# update the event count in lower right hand corner of window
	$event_count = $index." events loaded";
	kill 'SIGUSR1', $cpid;
	waitpid($cpid,0);   
	$mw->configure(-cursor=>'arrow'); 
    }
    else{
	exec("BSMVWR_HOME/working.pl");
    }
}

#######################
#
#
sub detail_dialog{
  
    my ($sel) = $ml->curselection;
    $x = $mw->x();
    $y = $mw->y();   
    $dw = $mw->Toplevel();
    $dw->title("Details");
    $dw->geometry("397x360+$x+$y");
    $dw->resizable(0,0);
   
    build_detail_dialog(); 
    populate_detail_dialog($sel);
 
    $dw->Button(-width=>10,-text=>"OK",-command=>sub{$dw->destroy()})
	->place(-x=>40,-y=>315);

    $dw->Button(-width=>10,-text=>"Prev",-command=>sub{
                                            if($sel-1 >= $min_entry){
						$ml->selectionClear($sel);
						$sel-=1;
						$ml->selectionSet($sel);
                                                $ml->see($sel);
						populate_detail_dialog($sel);
                                            }
					})->place(-x=>140,-y=>315);

     $dw->Button(-width=>10,-text=>"Next",-command=>sub{
                                            if($sel+1 <= $max_entry){
						$ml->selectionClear($sel);
						$sel+=1;
						$ml->selectionSet($sel);
                                                $ml->see($sel);
					#	$ml->focus();
						populate_detail_dialog($sel);
					    }
					   })->place(-x=>240,-y=>315);
    $dw->waitVisibility();
    $dw->grab();
    MainLoop;
}

##########################
#
#
sub build_detail_dialog{

    $dw->Label(-textvariable=>\$error_label)->place(-x=>15,-y=>30);
    $dw->Label(-textvariable=>\$cat_label)->place(-x=>15,-y=>50);
    $dw->Label(-textvariable=>\$date_label)->place(-x=>15,-y=>70);
    $dw->Label(-textvariable=>\$time_label)->place(-x=>15,-y=>90);
    $dw->Label(-textvariable=>\$ruid_label)->place(-x=>200,-y=>30);
    $dw->Label(-textvariable=>\$euid_label)->place(-x=>200,-y=>50);
    $dw->Label(-textvariable=>\$host_label)->place(-x=>200,-y=>70);

    $dw->Label(-text=>"Details")->place(-x=>15,-y=>120);
    $detail_box = $dw->Text(-height=>10,-width=>52)->place(-x=>15,-y=>150); 
}

#########################
#
#
sub populate_detail_dialog{

    my $index = shift;
    my $time;

    ($error,$cat,$date,$ruid,$euid,$host,$detail) =$ml->getRow($index);
     
    $error_label = sprintf("%s:     %s","Type",$error);
    $cat_label   = sprintf("%s:  %s","Source",$cat);

    @temp = (split(/ /,$date))[0,1,2,4];
    $date_label  = sprintf("%s:     %s %s %s %s","Date",@temp);
   
    $temp = (split(/ /,$date))[3];
    $time_label  = sprintf("%s:     %s","Time",$temp);
    
    $ruid_label  = sprintf("%s:  %s","Ruid",$ruid);
    $euid_label  = sprintf("%s:  %s","Euid",$euid);
    $host_label  = sprintf("%s:  %s","Host",$host);

    $detail_box->delete('1.0','end');
    $detail_box->insert('end',$detail);
}


####################################
# function to format event types
#
sub process_events {

    my $fh = shift;
    my $data = shift;
    my $i=0;
    my($err_code,$err_message,$category,$date,$ruid,$euid,$host,$details);

    while(<$fh>){   
	chomp();

	if(/^file/){
	    next;
	}   
	if(/^header/){
	    undef($details); 
	    ($category,$date) = (split(/,/))[3,5];
	    $category =~ s/AUE_//;
	}
	if(/^subject/){
	    ($ruid,$euid,$gid,$host) = (split(/,/))[1,2,3,8];
	    chomp($host);
	    $host = (split(/ /,$host))[2]; 
	}
	if(/^path/ || /^text/){
	    chomp();
	    if(defined($details)){
		$details = $details."\n          ".(split(/,/))[1];
	    }
	    else{
		$details = (split(/,/))[1];
	    }
	} 
	if(/^return/){
	    ($err_message,$err_code) = (split(/,/))[1,2];
	    ($err_message,$mes) = split(/:/,$err_message);  
	    if(defined($mes)){
		$details = $mes.", ".$details;
	    }
	    $details =~ s/^\s+//g; 
	    @$data = ($err_message,$category,$date,$ruid,$euid,$host,$details);
	    return 1;
	}
    }
    return 0;
}

1












